#!/bin/sh

#
# Clean
#
rm -f Shapes.py* Shapes.o Square.o _Shapes.so

#
# Compile the C++ code to be bound to Python
#
g++ -c Square.cc

#
#
# Generates the wrappers
#
swig -c++ -python -o Shapes.cc Shapes.i

#
# Compiles the C++ wrapper.
#
g++ -I/usr/include/python2.6/ -fPIC -c Shapes.cc

#
# Build the wrapper as a shared library.
#
gcc -shared -o _Shapes.so Shapes.o Square.o -lpython2.6 -lstdc++
