%module Shape
%{
#include "Shape.h"
%}

class Shape {
 public:
  virtual double area() const = 0;
  virtual double perimeter() const = 0;
  void setPosition(double x, double y);
};

%extend Shape {
double xPosition() const { return $self->getXPosition();}
double yPosition() const { return $self->getYPosition();}

};

class Square : public Shape {
 public:
  Square(double width);
  virtual ~Square();
  virtual double area() const;
  virtual double perimeter() const;
  
};

class Circle : public Shape {
 public:
  Circle(double radius);
  virtual ~Circle();
  virtual double area() const;
  virtual double perimeter() const;
  double radius() const;
  
};

%extend Circle {
  char* __str__() {
    static char temp[100];
    sprintf(temp, "I am a circle with a radius of %f and I am located at %f,%f", $self->radius(), $self->getXPosition(), $self->getYPosition());
    return &temp[0];
  }
};
